
** Stata (mata) commands for checking the covariance
** structure of random effects models proposed
** in:

* Rabe-Hesketh, S., Skrondal, A., and Gjessing, H. K. (2007).
* Biometrical modeling of twin and family data using standard mixed
* model software. Biometrics ??, ??-??.


mata

Z1=(0,0,0,0\ 0,0,0,0\ 0,0,sqrt(1/2),0\ 0,0,0,sqrt(1/2))
Z2=(1,0\ 1,0\ 0,sqrt(1/2)\0,sqrt(1/2))
Z3=(1,0\ 1,0\ 0,1\ 0,1)
Z4=(0,0,0,0\ 0,0,0,0\ 0,0,sqrt(3/4),0\ 0,0,0,sqrt(3/4))
Z5=(1,0\ 1,0\ 0,sqrt(1/4)\ 0,sqrt(1/4))
Z6=(1,0,0\ 1,0,0\ 0,1,0\ 0,0,1)
Z7=(1\ 0\ .5\ .5)
Z8=(0\ 1\ .5\ .5)
Z9=(1,0,0\ 0,1,0\ 0,0,1\ 0,0,1)

//4 by 4 unit matrix
I4=I(4)

// 4-dim. vector of ones
one4=J(4,1,1)

// ************ ACE (param 1) ** Section 4.1
// A
Z1*Z1'+Z2*Z2'

// C
Z3*Z3'

// ************ ADE (param 1) ** Section 4.1
// A
Z1*Z1'+Z2*Z2'

// D
Z4*Z4'+Z5*Z5'

// ************ ACE (param 2) ** Section 4.2
// A
(Z6*Z6'+Z3*Z3')/2

// C
(Z3*Z3')

// *********** ADE (param 2) ** Section 4.2
// A
(Z6*Z6'+Z3*Z3')/2

// D
(3*Z6*Z6'+Z3*Z3')/4

// ********** sibs and cousins ** Section 5.1
// A
(one4*one4'+3*Z3*Z3'+4*I4)/8

// C
Z3*Z3'

// ********* nuclear family ** Section 5.2
// A
Z7*Z7'+Z8*Z8'+Z1*Z1'

// C
Z9*Z9'


end
